<!-- 到期样品 -->
<script lang="ts" setup name="OverTimeList">
import { getCurrentInstance, ref } from 'vue'
import type { Ref } from 'vue'
import type { DateModelType } from 'element-plus'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IOvertimeList, IOvertimeListQuery } from './overtime_list_interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { printJSON } from '@/utils/printUtils'
import { exportFile } from '@/utils/exportUtils'
import { exportOverTimeList, getOverTimeList } from '@/api/customer/overtime'
import { deleteSample, exportSapmleList, getSampleList } from '@/api/customer/sampleList'
const { proxy } = getCurrentInstance() as any
const $router = useRouter()

// 查询条件
const listQuery: Ref<IOvertimeListQuery> = ref({
  sampleNo: '', // 样品编号
  sampleName: '', // 样品名称
  sampleModel: '', // 型号
  customerNo: '', // 委托方代码
  customerName: '', // 委托方名称
  startTime: '1', // 检定开始时间
  endTime: '1', // 检定结束时间
  offset: 1,
  limit: 20,
})
// 证书状况字典
const certificationStatusMap = {
  0: '未超期',
  1: '即将超期',
  2: '已超期',
}
const timeRange = ref<[DateModelType, DateModelType]>(['', ''])
// 表头
const columns = ref<TableColumn[]>([
  { text: '样品编号', value: 'sampleNo', width: '160', align: 'center' },
  { text: '样品名称', value: 'sampleName', width: '120', align: 'center' },
  { text: '型号', value: 'sampleModel', align: 'center' },
  { text: '出厂编号', value: 'evaluationName', align: 'center' },
  { text: '委托方代码', value: 'customerNo', align: 'center' },
  { text: '委托方名称', value: 'customerName', align: 'center' },
  { text: '检定周期', value: 'mesurePeriod', align: 'center' },
  { text: '上次检定时间', value: 'effectiveDate', align: 'center', width: '180px' },
  { text: '证书状况', value: 'certificationStatus', align: 'center' },
])
// 表格数据
const list = ref<IOvertimeList[]>([])
// 总数
const total = ref(0)
// 表格加载状态
const loadingTable = ref(false)
// 选中的内容
const checkoutList = ref<string[]>([])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  listQuery.value.startTime = timeRange.value[0] as string || ''
  listQuery.value.endTime = timeRange.value[1] as string || ''
  getSampleList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 点击详情
const handleEdit = (row: IOvertimeList, pageType: 'detail') => {
  $router.push(`/sample/overtime/${pageType}/${row.id}`)
}

// 点击搜索
const searchList = () => {
  fetchData(true)
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    sampleNo: '', // 样品编号
    sampleName: '', // 样品名称
    sampleModel: '', // 型号
    customerNo: '', // 委托方代码
    customerName: '', // 委托方名称
    startTime: '', // 检定开始时间
    endTime: '', // 检定结束时间
    offset: 1,
    limit: 20,
  }
  timeRange.value = ['', '']
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 导出
const exportAll = () => {
  const loading = ElLoading.service({
    lock: true,
    text: '下载中请稍后',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    const params = {
      sampleNo: listQuery.value.sampleNo, // 样品编号
      sampleName: listQuery.value.sampleName, // 样品名称
      sampleModel: listQuery.value.sampleModel, // 型号
      customerNo: listQuery.value.customerNo, // 委托方代码
      customerName: listQuery.value.customerName, // 委托方名称
      startTime: listQuery.value.startTime, // 投诉开始时间
      endTime: listQuery.value.endTime, // 投诉结束时间
      ids: checkoutList.value,
    }
    exportOverTimeList(params).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, '到期样品列表.xlsx')
    })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
  loading.close()
}

// 打印列表
function printList() {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '到期样品列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: any) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '到期样品列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

fetchData(true)
</script>

<template>
  <app-container>
    <search-area
      :need-clear="true"
      @search="searchList" @clear="clearList"
    >
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleNo"
          placeholder="样品编号"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleName"
          placeholder="样品名称"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleModel"
          placeholder="型号"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.customerNo"
          placeholder="委托方代码"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.customerName"
          placeholder="委托方名称"
          clearable
        />
      </search-item>
      <search-item>
        <search-item>
          <el-date-picker
            v-model="timeRange"
            type="datetimerange"
            range-separator="到"
            format="YYYY/MM/DD HH:mm:ss"
            value-format="YYYY-MM-DD h:m:s"
            start-placeholder="上次检定开始时间"
            end-placeholder="上次检定结束时间"
          />
        </search-item>
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/sample/overtime/export')" icon="icon-export" title="导出" type="primary" @click="exportAll" />
        <icon-button v-if="proxy.hasPerm('/sample/overtime/print')" icon="icon-print" title="打印" type="primary" @click="printList" />
      </template>
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery"
        :list-loading="loadingTable" is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
      >
        <template #columns>
          <el-table-column label="操作" align="center" width="80">
            <template #default="{ row }">
              <el-button
                size="small"
                link
                type="primary"
                @click="handleEdit(row, 'detail')"
              >
                详情
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

<style lang="scss" scoped>
// 样式
</style>
